        list p=16F84, R=DEC

        INCLUDE <CWKEY.INC>
;ELEKTRONSKI TASTER AJ PRE EME
        ORG     00h
        GOTO    START
;***********************
START   BSF     STATUS,RP0
        MOVLW   0             ;VSETKY SU VYSTUPY, NAMIESTO BIN KODU SA
        MOVWF   TRISA         ;POUZIL DEKADICKY
        MOVLW   B'00100000'   ;ZAPNI PULL UP ODPORY
        MOVWF   OPTI
        MOVLW   B'11111111'   ;VSETKY SU VSTUPY, MOHLO SA NAPISAT AJ V HEXA
        MOVWF   TRISB         ;AKO 0FFh
        BCF     STATUS,RP0
        MOVLW   B'00000110'   ;BITY 0 A 3 RESETUJ A 1 2 SETUJ
        MOVWF   TRISA
        CALL    VYMAZ         ;VYMZ VSETKY OM REGISTRY
        MOVLW   B'00011000'   ;UMOZNI NAVRAT ZO SLEEP REZIMU - POZRIET BITY
        MOVWF   INTCON        ;V INTCON REGISTRI
        MOVLW   0FFh          ;MARKER ABY NECITAL Z PAMATI AK JE PRAZDNA
        MOVWF   OM1
        ;**********************
TEST3   BTFSS   PB,ZAPIS
        GOTO    ZAPISI
        BTFSS   PB,BODKY
        CALL    BOD
        BTFSS   PB,CIARKY
        CALL    CIARI
;***********************
SLEP    BTFSS   PB,BODKY      ;PREVER CI NEKLUCUJE
        GOTO    TEST3
        BTFSS   PB,CIARKY
        GOTO    TEST3
        SLEEP                 ;AK NIE VYKONAJ INSTRUKCIU SLEEP
        BCF     INTCON,1      ;BUDENIE PRICHADZA OD PB, PRETO TREBA RESETOVAT
        BCF     INTCON,0      ;TIETO BITY, ONI SA ZAKAZDYM SETUJU PRI BUDENI
        BTFSS   PB,CITAJ
        GOTO    CITA
        BTFSS   PB,CITMEM
        GOTO    CITAMM
        BTFSS   PB,MEMOR
        GOTO    MEMORI
        GOTO    TEST3
;**********************
;BODKY
BOD     BSF     PA,0          ;KLUCUJ VYSIELAC
        BSF     PA,3          ;ZASVIET LED
        BCF     PA,1          ;KLUCUJ PIPATKO
        CALL    KRATKE        ;ZAVOLAJ DOBU TRVANIA JEDNEJ BODKY
        BCF     PA,0          ;NASLEDUJE MEDZERA V PISMENE
        BCF     PA,3
        BSF     PA,1
        CALL    KRATKE        ;DLZKA MEDZERY
        RETURN
;***********************
;POMLCKY
CIARI   BSF     PA,0          ;ROVNAKO AKO PRI BODKACH
        BSF     PA,3
        BCF     PA,1
        CALL    KRATKE        ;ZAVOLAJ DOBU TRVANIA JEDNEJ POMLCKY JE
        CALL    KRATKE
        CALL    KRATKE
        BCF     PA,0          ;TRI KRAT DLHSIA AKO BODKA
        BCF     PA,3
        BSF     PA,1
        CALL    KRATKE        ;NASLEDUJE MEDZERA
        RETURN
;***********************
;ZAPISUJE DO PAMATI
;**********************
ZAPISI  CALL    VYMAZ
        MOVLW   11h
        MOVWF   FSR
        MOVLW   .9
        MOVWF   CWK2
        CLRF    CWK5
TEST2   BTFSC   PB,ZAPIS      ;PREVERUJE CI SA NEPRESTALO ZAPISOVAT
        GOTO    QAP
        BTFSS   PB,BODKY
        CALL    BOD1
        BTFSS   PB,CIARKY
        CALL    CIARY1
        BTFSS   PB,BODKY      ;DVAKRAT TESTUJEME ABY SA PREVERILO CI SA
        GOTO    TEST2         ;ROBI MEDZERA AJ AKA DLHA
        BTFSS   PB,CIARKY
        GOTO    TEST2
        CALL    BOD2          ;UROB PRAVIDELNU MEDZERU
        GOTO    TEST2
        INCLUDE <ZAPISI.INC>  ;ODTIALTO FUNGUJE INC SUBOR ZAPISI KTORY JE
;***********************      ;PRILIS VELKY
;CITA Z PAMATE
CITA    MOVLW   11h
        INCLUDE <CITA.INC>    ;SUBOR JE DOST VELKY, PRETO JE VYTVORENY INC
;****************************
MEMORI  BCF     PA,2          ;ZAPISUJE DO DRUHEJ PAMATI
        INCLUDE <MEMORI.INC>
;**********************
KRATKE  BTFSC   PB,ZAPIS      ;AK JE STLACENE TLACITKO ZAPIS
        GOTO    KRA
        BTFSC   PB,CITAJ      ;POZRI CI SA NECITA EME Z PRVEJ MEM
        GOTO    KRAK
        GOTO    KRA1
KRAK    BTFSC   PB,CITMEM     ;POZRI CI SA NECITA EME Z EEPROM
        GOTO    KRA
        GOTO    KRA1
KRA     MOVLW   .20           ;CAS URCENY NA BODKY  NORMAL
        MOVWF   TMP2
TMPP4   MOVLW   .255
        MOVWF   TMP3
TMPP3   DECFSZ  TMP3,f
        GOTO    TMPP3
        DECFSZ  TMP2,f
        GOTO    TMPP4
        RETURN
KRA1    MOVLW   .2           ;CAS URCENY NA BODKY  EME
        MOVWF   TMP2
TMPP41  MOVLW   .255
        MOVWF   TMP3
TMPP31  DECFSZ  TMP3,f
        GOTO    TMPP31
        DECFSZ  TMP2,f
        GOTO    TMPP41
        RETURN
;**********************
DLHE    BTFSC   PB,ZAPIS      ;TOTO JE PRE EME
        GOTO    DLH
        BTFSC   PB,CITAJ
        GOTO    DLHA
        GOTO    DLH1
DLHA    BTFSC   PB,CITMEM
        GOTO    DLH
        GOTO    DLH1
DLH     MOVLW   .60           ;CAS URCENY NA POMLCKY NORMAL
        MOVWF   TMP2
        GOTO    TMPP41
TMPP43  MOVLW   .255
        MOVWF   TMP3
TMPP33  DECFSZ  TMP3,f
        GOTO    TMPP33
        DECFSZ  TMP2,f
        GOTO    TMPP43
        RETURN
DLH1    MOVLW   .6           ;CAS URCENY NA POMLCKY EME
        MOVWF   TMP2
        GOTO    TMPP41
TMPP42  MOVLW   .255
        MOVWF   TMP3
TMPP32  DECFSZ  TMP3,f
        GOTO    TMPP32
        DECFSZ  TMP2,f
        GOTO    TMPP42
        RETURN
;***********************
CITAMM  BCF    PA,2           ;INCLUDE SUBOR SA VZDY MUSI ZAPISOVAT NA TENTO
        INCLUDE <CITAM.INC>   ;SPOSOB; NAJPRV MUSI IST DAJAK INSTRUKCIA
         ;                    ;NAPR.  CITAMM  BCF      PA,2 A POTOM INC SUBOR
VYMAZ   BCF     PA,1          ;PRVA INSTRUKCIA V INC SUBORE NALSEDUJE PREDCHA-
        INCLUDE <VYMAZ.INC>   ;DZAJUCU
;*****************************
SCAN    MOVLW  .150
        MOVWF  TMP3
LOOP1   MOVLW  .30
        MOVWF  TMP2
        MOVLW  B'11110101'
        ANDWF  PB,W
        MOVWF  CWK1
LOOP2   MOVLW  B'11110101'
        ANDWF  PB,W
        XORWF  CWK1,W
        BTFSS  STATUS,Z
        GOTO   SCAN
        DECFSZ TMP2,f
        GOTO   LOOP2
        DECFSZ TMP3,f
        GOTO   LOOP1
        RETURN
        END